#pragma once
#ifndef SERVER_TEST_SOCKET_ASYNC_SOCKET_CONNECTION_MANAGER_INCLUDED__
#define SERVER_TEST_SOCKET_ASYNC_SOCKET_CONNECTION_MANAGER_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: AsyncSocketConnectionManager.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/SocketTools/DatagramSocketConnectionManager.h"
#include "JetByteTools/SocketTools/DatagramSocketConnectionManagerCallback.h"

///////////////////////////////////////////////////////////////////////////////
// CAsyncSocketConnectionManager
///////////////////////////////////////////////////////////////////////////////

class CAsyncSocketConnectionManager :
   public JetByteTools::Socket::CDatagramSocketConnectionManager,
   private JetByteTools::Socket::CDatagramSocketConnectionManagerCallback
{
   public :

      CAsyncSocketConnectionManager(
         JetByteTools::IO::IIOPool &pool,
         JetByteTools::Socket::IAllocateDatagramSockets &socketAllocator,
         JetByteTools::IO::IAllocateBuffers &bufferAllocator);

   private :

      void OnReadCompleted(
         JetByteTools::Socket::IDatagramSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      /// No copies do not implement
      CAsyncSocketConnectionManager(const CAsyncSocketConnectionManager &rhs);
      /// No copies do not implement
      CAsyncSocketConnectionManager &operator=(const CAsyncSocketConnectionManager &rhs);
};

#endif // SERVER_TEST_SOCKET_ASYNC_SOCKET_CONNECTION_MANAGER_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: AsyncSocketConnectionManager.h
///////////////////////////////////////////////////////////////////////////////
