#pragma once
#ifndef ECHO_SERVER_UDP_TEST_COMMAND_LINE_INCLUDED__
#define ECHO_SERVER_UDP_TEST_COMMAND_LINE_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: CommandLine.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2006 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/CoreTools/Types.h"
#include "JetByteTools/CoreTools/CommandLine.h"

#include "JetByteTools/SocketTools/ConsecutiveSocketOperations.h"
#include "JetByteTools/SocketTools/PerSocketBufferPoolingLimit.h"

///////////////////////////////////////////////////////////////////////////////
// CCommandLine
///////////////////////////////////////////////////////////////////////////////

class CCommandLine
{
   public :

      typedef unsigned short Count;

      CCommandLine();

      CCommandLine(
         const CCommandLine &rhs) = delete;

      CCommandLine &operator=(
         const CCommandLine &rhs) = delete;

      bool Parse(
         DWORD argc,
         const char **argv);

      JetByteTools::Core::_tstring Server() const;

      unsigned short Port() const;

      Count Repeats() const;

      Count Packets() const;

      Count PacketSize() const;

      Count PacketBatchSize() const;

      Count PacketBatchPause() const;

      bool PreAllocate() const;

      Count SpinCount() const;

      JetByteTools::Milliseconds ReadTimeout() const;

      bool DumpRTT() const;

      JetByteTools::Milliseconds DataFlowTimeout() const;

      JetByteTools::Milliseconds DisplayStatusEvery() const;

      JetByteTools::Socket::PerSocketBufferPoolingLimit MaxBuffersPooledPerSocket() const;

      JetByteTools::Socket::ConsecutiveSocketOperations MaxConsecutiveOperationsOnOneSocket() const;

      void ShowHelp(
         const JetByteTools::Core::_tstring &message);

   private :

      static Count StringToCount(
         const JetByteTools::Core::_tstring &stringValue);

      JetByteTools::Core::CCommandLine m_parser;
};

#endif // ECHO_SERVER_UDP_TEST_COMMAND_LINE_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: CommandLine.h
///////////////////////////////////////////////////////////////////////////////
