#pragma once
#ifndef ECHO_SERVER_UDP_TEST_I_TEST_DATAGRAM_INCLUDED__
#define ECHO_SERVER_UDP_TEST_I_TEST_DATAGRAM_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: ITestDatagram.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2009 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/CoreTools/Types.h"

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

class CRoundTripTimes;

///////////////////////////////////////////////////////////////////////////////
// ITestDatagram
///////////////////////////////////////////////////////////////////////////////

class ITestDatagram
{
   public :

      typedef unsigned long DataLength;

      virtual ~ITestDatagram() {}

      virtual void ExpectRepeats(
         size_t numberOfRepeats) = 0;

      virtual DWORD GetIdentifier() const = 0;

      virtual const BYTE * const GetBytes() = 0;

      virtual DataLength GetSize() const = 0;

      virtual void ValidateResponse(
         const BYTE *pData,
         DataLength dataLength) = 0;

      virtual const CRoundTripTimes &GetTimes() const = 0;
};

#endif // ECHO_SERVER_UDP_TEST_I_TEST_DATAGRAM_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: ITestDatagram.h
///////////////////////////////////////////////////////////////////////////////
