#pragma once
#ifndef ECHO_SERVER_UDP_TEST_TEST_DATAGRAM_INCLUDED__
#define ECHO_SERVER_UDP_TEST_TEST_DATAGRAM_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: TestDatagram.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2009 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "ITestDatagram.h"

#include "ServerCommon/RoundTripTimes.h"

///////////////////////////////////////////////////////////////////////////////
// CTestDatagram
///////////////////////////////////////////////////////////////////////////////

class CTestDatagram : public ITestDatagram
{
   public :

      CTestDatagram(
         DWORD id,
         DataLength messageSize);

      // Implement ITestDatagram

      virtual ~CTestDatagram();

      void ExpectRepeats(
         size_t numberOfRepeats) override;

      DWORD GetIdentifier() const override;

      const BYTE * const GetBytes() override;

      DataLength GetSize() const override;

      void ValidateResponse(
         const BYTE *pData,
         DataLength dataLength) override;

      const CRoundTripTimes &GetTimes() const override;

   private :

      const DWORD m_id;

      const DataLength m_messageSize;

      BYTE *m_pData;

      CRoundTripTimes m_times;

      size_t m_repeatCount;

      mutable size_t m_currentSendIteration;

      mutable size_t m_currentRecvIteration;

      // No copies do not implement
      CTestDatagram(const CTestDatagram &rhs);
      CTestDatagram &operator=(const CTestDatagram &rhs);
};

#endif // ECHO_SERVER_UDP_TEST_TEST_DATAGRAM_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: TestDatagram.h
///////////////////////////////////////////////////////////////////////////////
