@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet
if not defined NUM_PACKETS set NUM_PACKETS=500

goto DisplayDebug

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:DisplayDebug

if not defined JETBYTE_DEBUG_BUILD_SCRIPTS goto NoDebug

Echo Script debug information - RunTests.bat
Echo - 
Echo Required: SERVER=%SERVER%
Echo Required: BASE_ARGS=%BASE_ARGS%
Echo -

:NoDebug

:RunTests

setlocal

set TEST_NAME=%BASE_TEST_NAME% EchoServerUDPTest.exe
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\EchoServerUDPTest.exe"
set TEST_CLIENT_ARGS=-server localhost -port 5050 -packets %NUM_PACKETS% -packetSize 1024 -readTimeout 5000 -displayStatusEvery 1000

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

